# coding: utf-8
require_relative '../constants'

class AuthManager::Adder < AuthManager::Constants

  def self.save?(given_user, option={user: true, app: false})
    user = option.fetch(:user) || false
    app  = option.fetch(:app) || false
    response = {}
    #section to allow new validation class to work with a hash
    hash = hash_format_of(given_user, option)
    #end of section
    #hash for base redis_sadd
    validation_mess = AuthManager::Validation.validate_param( hash )
    hash_for_base = { object: hash[:object], list: 'users' } if hash[:option][:user]
    hash_for_base = { object: hash[:object], list: 'applications' } if hash[:option][:app]
    response = AuthManager::Base.redis_sadd(hash_for_base) if (validation_mess[:code] == 200)
    response[:code] == 200 ? true : false
  end

  private ###################################

  def self.hash_format_of(given_user, option)
    parsed  = JSON.parse(given_user)
    object = {}
    object = { login: parsed['login'], password: parsed['password'] } if parsed['login']
    object = { api_key: parsed['api_key'] } if parsed['api_key']
    object[:deleted] = true if parsed['deleted']
    { object: object, option: option }
  end

end
