require 'redis'

class AuthManager::Base

  def self.redis_sadd(hash)
    validation = hash_of_pair(hash)
    added = false
    validation[:code] == 200 ? added = Redis.current.sadd(hash[:list], hash[:object].to_json) : (return validation)
    added ? {code: 200, message: 'Param saved.'} : { code: 403, message: 'Sorry, This object already exists.'  }
  end

  def self.redis_smembers(hash)
    validation = hash_of_single(hash)
    found = false
    validation[:code] == 200 ? found = Redis.current.smembers(hash[:list]) : (return validation)
    found.class == Array ? { code: 200, message: found } : { code: 404, message: 'Param not found!' }
  end

  def self.redis_sismember(hash)
    validation = hash_of_pair(hash)
    is_member = false
    validation[:code] == 200 ? is_member = Redis.current.sismember(hash[:list], hash[:object].to_json) : (return validation)
    is_member ? {code: 200, message: 'Param is a member of the given list.'} : { code: 404, message: 'Sorry, param not in the list'  }
  end

  def self.redis_srem(hash)
    validation = hash_of_pair(hash)
    removed = false
    validation[:code] == 200 ? removed = Redis.current.srem(hash[:list], hash[:object].to_json) : (return validation)
    removed ? {code: 200, message: 'Param removed.'} : { code: 404, message: 'Sorry, param not in the list, thus not removed'  }
  end

  def self.redis_del(hash)
    validation = hash_of_single(hash)
    deleted = 0
    validation[:code] == 200 ? deleted = Redis.current.del(hash[:list]) : (return validation)
    deleted != 0 ? {code: 200, message: 'Param deleted.'} : { code: 404, message: 'Sorry, param list not found'  }
  end

  private #######################################

  def self.hash_of_pair(hash)
    to_return = {code: 400, message: 'Param is not a hash!'}
    if (hash.class == Hash) && (hash.include?(:list) && hash.include?(:object))
      to_return = {code: 200, message: 'Valid hash.'}
    elsif (hash.class == Hash)
      to_return = {code: 400, message:'Hash not well formed!'}
    end
    to_return
  end

  def self.hash_of_single(hash)
    to_return = {code: 400, message: 'Param is not a hash!'}
    if ((hash.class == Hash) && (hash.include?(:list)))
      to_return = {code: 200, message: 'Valid hash.'}
    elsif (hash.class == Hash)
      to_return = {code: 400, message:'Hash not well formed!'}
    end
    to_return
  end

end

