class AuthManager::Finder < AuthManager::Constants

  def self.find_object?( param, option )
    user = option.fetch(:user) || false
    app = option.fetch(:app) || false
    hash = hash_format_of(param, option)
    AuthManager::Validation.validate_param( hash )
    liste = user ? USERS : APPS
    hash_for_base = { object: hash[:object], list: 'users' } if hash[:option][:user]
    hash_for_base = { object: hash[:object], list: 'applications' } if hash[:option][:app]
    response = {}
    response = exist?(hash_for_base)
    response[:code] == 200 ? true : false
  end

  private #############################

  def self.hash_format_of(given_user, option)
    object = JSON.parse(given_user)
    object = { login: object['login'], password: object['password'] } if object['login']
    object = { api_key: object['api_key'] } if object['api_key']
    { object: object, option: option }
  end

  def self.exist?( hash_for_base )
    AuthManager::Base.redis_sismember( hash_for_base )
  end
end
