# coding: utf-8
require_relative '../base'
require_relative '../constants'

class AuthManager::Updater < AuthManager::Constants

  def self.update(old_obj, new_obj, option)
    updated = false
    if AuthManager::Finder.find_object?(old_obj, option)
      if p AuthManager::Adder.save?(new_obj, option)
        updated = delete_obj?(old_obj, option)
      end
    end
    updated
  end

  private ###########################

  def self.hash_format_of(given_user, option)
    object = JSON.parse(given_user)
    object = { login: object['login'], password: object['password'] } if object['login']
    object = { api_key: object['api_key'] } if object['api_key']
    { object: object, option: option }
  end

  def self.delete_obj?(old_obj, option)
    user = option.fetch(:user) || false
    liste = user ? USERS : APPS
    hash = hash_format_of(old_obj, option)
    hash_for_base = { object: hash[:object], list: 'users' } if hash[:option][:user]
    hash_for_base = { object: hash[:object], list: 'applications' } if hash[:option][:app]
    done = AuthManager::Base.redis_srem(hash_for_base)
    done[:code] == 200 ? true : false
  end

end
